/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.log.enums.YYLoggerTuJingEnum
 *  fire.pb.PropRole
 *  fire.pb.StateCommon
 *  fire.pb.battle.watch.PEndWatchBattle
 *  fire.pb.buff.BuffRoleImpl
 *  fire.pb.buff.Module
 *  fire.pb.buff.continual.ConstantlyBuff
 *  fire.pb.circletask.CircleTaskManager
 *  fire.pb.item.Pack
 *  fire.pb.map.GridPos
 *  fire.pb.map.Role
 *  fire.pb.map.RoleManager
 *  fire.pb.mission.activelist.RoleLiveness
 *  fire.pb.scene.BlockInfo
 *  fire.pb.talk.MessageMgr
 *  fire.pb.team.Team
 *  fire.pb.team.TeamManager
 *  fire.pb.util.MapUtil
 *  mkdb.Lockeys
 *  mkdb.Procedure
 *  mkdb.TTable
 *  xtable.Locks
 */
package fire.pb.battle;

import fire.log.enums.YYLoggerTuJingEnum;
import fire.pb.PropRole;
import fire.pb.StateCommon;
import fire.pb.battle.PNewBattle;
import fire.pb.battle.PlayPKEndHandler;
import fire.pb.battle.watch.PEndWatchBattle;
import fire.pb.buff.BuffRoleImpl;
import fire.pb.buff.Module;
import fire.pb.buff.continual.ConstantlyBuff;
import fire.pb.circletask.CircleTaskManager;
import fire.pb.item.Pack;
import fire.pb.map.GridPos;
import fire.pb.map.Role;
import fire.pb.map.RoleManager;
import fire.pb.mission.activelist.RoleLiveness;
import fire.pb.scene.BlockInfo;
import fire.pb.talk.MessageMgr;
import fire.pb.team.Team;
import fire.pb.team.TeamManager;
import fire.pb.util.MapUtil;
import java.util.ArrayList;
import java.util.List;
import mkdb.Lockeys;
import mkdb.Procedure;
import mkdb.TTable;
import xtable.Locks;

public class PPlayPKBattle
extends Procedure {
    private final long hostid;
    private final long guestid;

    public PPlayPKBattle(long hostroleid, long guestRoleID) {
        this.hostid = hostroleid;
        this.guestid = guestRoleID;
    }

    protected boolean process() throws Exception {
        RoleLiveness gestrole;
        BuffRoleImpl buffRoleImpl;
        GridPos gpos;
        ArrayList<Long> roleids = new ArrayList<Long>();
        roleids.add(this.hostid);
        roleids.add(this.guestid);
        this.lock(Lockeys.get((TTable)Locks.ROLELOCK, roleids));
        PropRole hostRole = new PropRole(this.hostid, false);
        PropRole guestRole = new PropRole(this.guestid, true);
        int guest_Level = guestRole.getLevel();
        int host_Level = hostRole.getLevel();
        if (guest_Level < 20 || host_Level < 20) {
            MessageMgr.sendMsgNotify((long)this.hostid, (int)145000, (int)0, null);
            return true;
        }
        if (!StateCommon.isOnlineBuffer((long)this.guestid)) {
            MessageMgr.psendMsgNotify((long)this.hostid, (int)140534, null);
            return false;
        }
        Role role = RoleManager.getInstance().getRoleByID(this.hostid);
        BlockInfo blockinfo = MapUtil.getBlockInfo((int)role.getMapId());
        if (!blockinfo.checkCanQiecuo((gpos = role.getPos().toGridPos()).getX(), gpos.getY())) {
            Pack bag = new Pack(this.hostid, false);
            int nitemnum = bag.getBagItemNum(40014);
            if (nitemnum < 1) {
                MessageMgr.psendMsgNotify((long)this.hostid, (int)198159, null);
                return true;
            }
            ConstantlyBuff cbuff1 = Module.getInstance().createConstantlyBuff(507033);
            BuffRoleImpl agent = new BuffRoleImpl(this.hostid);
            agent.addCBuffWithSP(cbuff1);
            bag.removeItemById(40014, 1, YYLoggerTuJingEnum.tujing_Value_shengsizhan, 0, "pk扣除");
        }
        if ((buffRoleImpl = new BuffRoleImpl(this.guestid, true)).existState(507005)) {
            new PEndWatchBattle(this.guestid).call();
        }
        if (buffRoleImpl.existState(507027)) {
            buffRoleImpl.removeCBuff(507027);
        }
        this.sendMsgToRole(hostRole, this.guestid);
        this.sendMsgToRole(guestRole, this.hostid);
        PNewBattle newbattle = new PNewBattle(this.hostid, this.guestid, 11, new PlayPKEndHandler());
        newbattle.setCanRunaway(true);
        PPlayPKBattle.pexecuteWhileCommit((Procedure)newbattle);
        RoleLiveness actrole = RoleLiveness.getRoleLiveness((long)this.hostid);
        if (actrole != null) {
            actrole.addActiveNum(10);
        }
        if ((gestrole = RoleLiveness.getRoleLiveness((long)this.guestid)) != null) {
            gestrole.addActiveNum(10);
        }
        return true;
    }

    private void sendMsgToRole(PropRole role, long otherid) {
        String schoolName = CircleTaskManager.getInstance().getSchoolName(role.getSchool());
        int level = role.getLevel();
        ArrayList<String> paras = new ArrayList<String>();
        paras.add(String.valueOf(level));
        paras.add(schoolName);
        Team team = TeamManager.getTeamByRoleId((long)otherid);
        List role_members = null;
        if (team != null && team.isNormalMember(otherid)) {
            role_members = team.getNormalMemberIds();
        } else {
            role_members = new ArrayList<Long>();
            role_members.add(otherid);
        }
        for (Long mem : role_members) {
            MessageMgr.sendMsgNotify((long)mem, (int)120067, paras);
        }
    }
}

